import { computed as y, ref as k, watch as I, onMounted as X, openBlock as s, createElementBlock as r, normalizeStyle as g, createElementVNode as d, toDisplayString as _, createCommentVNode as h, unref as b, createVNode as W, Fragment as D, renderList as N, normalizeClass as P, createBlock as J, renderSlot as K } from "vue";
import { u as Q, c as U, t as R, a as Y, p as i, d as C, b as Z, o as ee, e as V, g as te, f as O, X as le, s as ae, w as oe, i as se } from "./index-49zKC_pb.js";
import { u as G } from "./useNestedProp-D1a8xzOZ.js";
import ne from "./vue-ui-skeleton-CWI6cZZA.js";
import { _ as re } from "./PackageVersion-ldwwWp9S.js";
import { _ as ue } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const ie = ["xmlns", "viewBox"], ce = ["id"], de = ["stop-color"], ve = ["stop-color"], ge = ["stop-color"], pe = {
  id: "stackPill",
  clipPathUnits: "objectBoundingBox"
}, he = ["fill"], fe = {
  key: 0,
  "clip-path": "url(#stackPill)"
}, ye = ["height", "width", "fill"], me = ["onClick", "x", "width", "height", "fill", "stroke"], ke = ["width", "height", "rx"], _e = ["onClick"], be = { style: { display: "flex", "flex-direction": "row", "align-items": "center", gap: "4px", "justify-content": "center" } }, we = ["height", "width"], xe = ["fill"], Ce = {
  key: 4,
  ref: "source",
  dir: "auto"
}, $e = {
  __name: "vue-ui-sparkstackbar",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectDatapoint"],
  setup(M, { emit: T }) {
    const u = M, { vue_ui_sparkstackbar: q } = Q(), z = y(() => !!u.dataset && u.dataset.length), A = k(U()), e = y({
      get: () => L(),
      set: (t) => t
    });
    function L() {
      const t = G({
        userConfig: u.config,
        defaultConfig: q
      });
      return t.theme ? {
        ...G({
          userConfig: R.vue_ui_sparkstackbar[t.theme] || u.config,
          defaultConfig: t
        }),
        customPalette: Y[t.theme] || i
      } : t;
    }
    I(() => u.config, (t) => {
      e.value = L(), B();
    }, { deep: !0 }), I(() => u.dataset, (t) => {
      m.value = u.dataset.map((a, l) => ({
        ...a,
        color: a.color ? C(a.color) : w.value[l] || i[l] || i[l % i.length]
      }));
    }, { deep: !0 });
    const w = y(() => Z(e.value.customPalette)), m = k(u.dataset.map((t, a) => ({
      ...t,
      value: e.value.style.animation.show ? 0 : t.value || 0,
      color: t.color ? C(t.color) : w.value[a] || i[a] || i[a % i.length]
    }))), x = k(!0);
    X(() => {
      if (B(), e.value.style.animation.show) {
        let f = function() {
          o += l / t, o < l ? (m.value = m.value.map((n, c) => ({
            ...n,
            value: n.value += a[c],
            color: n.color ? C(n.color) : w.value[c] || i[c] || i[c % i.length]
          })), requestAnimationFrame(f)) : (x.value = !1, m.value = u.dataset.map((n, c) => ({
            ...n,
            value: n.value || 0,
            color: n.color ? C(n.color) : w.value[c] || i[c] || i[c % i.length],
            id: U()
          })));
        };
        const t = e.value.style.animation.animationFrames, a = u.dataset.map((n, c) => n.value / t), l = u.dataset.map((n) => n.value || 0).reduce((n, c) => n + c, 0);
        let o = 0;
        x.value = !0, f();
      }
    });
    function B() {
      ee(u.dataset) ? V({
        componentName: "VueUiSparkStackbar",
        type: "dataset"
      }) : u.dataset.forEach((t, a) => {
        te({
          datasetObject: t,
          requiredAttributes: ["name", "value"]
        }).forEach((l) => {
          V({
            componentName: "VueUiSparkStackbar",
            type: "datasetSerieAttribute",
            property: l,
            index: a
          });
        });
      });
    }
    const p = k({
      width: 500,
      height: 16
    }), v = k([]), F = y(() => u.dataset.map((t) => t.value || 0).filter((t, a) => !v.value.includes(a)).reduce((t, a) => t + a, 0)), j = y(() => m.value.map((t, a) => {
      const l = t.value || 0, o = l / F.value, f = isNaN(o) ? 0 : o, n = f * p.value.width;
      return {
        ...t,
        value: l,
        proportion: f,
        width: n,
        proportionLabel: O({
          v: f * 100,
          s: "%",
          r: e.value.style.legend.percentage.rounding
        })
      };
    })), $ = y(() => j.value.filter((t, a) => !v.value.includes(a)));
    function H(t) {
      v.value.includes(t) ? v.value = v.value.filter((a) => a !== t) : v.value.length < m.value.length - 1 && v.value.push(t);
    }
    const S = y(() => {
      let t = 0;
      const a = [];
      for (let l = 0; l < $.value.length; l += 1)
        a.push({
          ...$.value[l],
          start: t
        }), t += $.value[l].width;
      return a;
    });
    function E(t, a) {
      T("selectDatapoint", { datapoint: t, index: a });
    }
    return (t, a) => (s(), r("div", {
      style: g(`width:100%; background:${e.value.style.backgroundColor}`)
    }, [
      e.value.style.title.text ? (s(), r("div", {
        key: 0,
        style: g(`width:calc(100% - 12px);background:transparent;margin:0 auto;margin:${e.value.style.title.margin};padding: 0 6px;text-align:${e.value.style.title.textAlign}`)
      }, [
        d("div", {
          style: g(`font-size:${e.value.style.title.fontSize}px;color:${e.value.style.title.color};font-weight:${e.value.style.title.bold ? "bold" : "normal"}`)
        }, _(e.value.style.title.text), 5),
        e.value.style.title.subtitle.text ? (s(), r("div", {
          key: 0,
          style: g(`font-size:${e.value.style.title.subtitle.fontSize}px;color:${e.value.style.title.subtitle.color};font-weight:${e.value.style.title.subtitle.bold ? "bold" : "normal"}`)
        }, _(e.value.style.title.subtitle.text), 5)) : h("", !0)
      ], 4)) : h("", !0),
      z.value ? (s(), r("svg", {
        key: 1,
        xmlns: b(le),
        width: "100%",
        viewBox: `0 0 ${p.value.width} ${p.value.height}`
      }, [
        W(re),
        d("defs", null, [
          (s(!0), r(D, null, N(S.value, (l, o) => (s(), r("linearGradient", {
            key: `stack_gradient_${o}`,
            gradientTransform: "rotate(90)",
            id: `stack_gradient_${o}_${A.value}`
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": l.color
            }, null, 8, de),
            d("stop", {
              offset: "50%",
              "stop-color": b(ae)(b(oe)(l.color, 0.05), 100 - e.value.style.bar.gradient.intensity)
            }, null, 8, ve),
            d("stop", {
              offset: "100%",
              "stop-color": l.color
            }, null, 8, ge)
          ], 8, ce))), 128)),
          d("clipPath", pe, [
            d("rect", {
              x: "0.005",
              y: "-2",
              width: "0.99",
              height: "5",
              rx: "3",
              ry: "3",
              fill: e.value.style.backgroundColor
            }, null, 8, he)
          ])
        ]),
        F.value > 0 ? (s(), r("g", fe, [
          d("rect", {
            x: 0,
            y: 0,
            height: p.value.height,
            width: S.value.map((l) => l.width).reduce((l, o) => l + o, 0),
            fill: e.value.style.bar.gradient.underlayerColor,
            class: P({ animated: !x.value })
          }, null, 10, ye),
          (s(!0), r(D, null, N(S.value, (l, o) => (s(), r("rect", {
            key: `stack_${o}`,
            onClick: () => E(l, o),
            x: l.start,
            y: 0,
            width: l.width,
            height: p.value.height,
            fill: e.value.style.bar.gradient.show ? `url(#stack_gradient_${o}_${A.value})` : l.color,
            stroke: e.value.style.backgroundColor,
            "stroke-linecap": "round",
            class: P({ animated: !x.value })
          }, null, 10, me))), 128))
        ])) : (s(), r("rect", {
          key: 1,
          x: 2,
          y: 1,
          width: p.value.width - 4,
          height: p.value.height - 2,
          stroke: "#CCCCCC",
          "stroke-width": "2",
          fill: "transparent",
          rx: (p.value.height - 4) / 2
        }, null, 8, ke))
      ], 8, ie)) : h("", !0),
      z.value ? h("", !0) : (s(), J(ne, {
        key: 2,
        config: {
          type: "sparkStackbar",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            sparkStackbar: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      e.value.style.legend.show ? (s(), r("div", {
        key: 3,
        style: g(`background:transparent;margin:0 auto;margin:${e.value.style.legend.margin};justify-content:${e.value.style.legend.textAlign === "left" ? "flex-start" : e.value.style.legend.textAlign === "right" ? "flex-end" : "center"}`),
        class: "vue-ui-sparkstackbar-legend"
      }, [
        (s(!0), r(D, null, N(j.value, (l, o) => (s(), r("div", {
          style: g(`font-size:${e.value.style.legend.fontSize}px;`),
          class: P({ "vue-ui-sparkstackbar-legend-item": !0, "vue-ui-sparkstackbar-legend-item-unselected": v.value.includes(o) }),
          onClick: (f) => {
            H(o), E(l, o);
          }
        }, [
          d("div", be, [
            (s(), r("svg", {
              height: `${e.value.style.legend.fontSize}px`,
              width: `${e.value.style.legend.fontSize}px`,
              viewBox: "0 0 10 10"
            }, [
              d("circle", {
                cx: 5,
                cy: 5,
                r: 5,
                fill: l.color
              }, null, 8, xe)
            ], 8, we)),
            d("span", {
              style: g(`color:${e.value.style.legend.name.color}; font-weight:${e.value.style.legend.name.bold ? "bold" : "normal"}`)
            }, _(l.name), 5),
            e.value.style.legend.percentage.show ? (s(), r("span", {
              key: 0,
              style: g(`font-weight:${e.value.style.legend.percentage.bold ? "bold" : "normal"};color:${e.value.style.legend.percentage.color}`)
            }, _(v.value.includes(o) ? " - " : l.proportionLabel), 5)) : h("", !0),
            e.value.style.legend.value.show ? (s(), r("span", {
              key: 1,
              style: g(`font-weight:${e.value.style.legend.value.bold ? "bold" : "normal"};color:${e.value.style.legend.value.color}`)
            }, " (" + _(b(se)(
              e.value.style.legend.value.formatter,
              l.value,
              b(O)({
                p: e.value.style.legend.value.prefix,
                v: l.value,
                s: e.value.style.legend.value.suffix,
                r: e.value.style.legend.value.rounding
              }),
              { datapoint: l, seriesIndex: o }
            )) + ") ", 5)) : h("", !0)
          ])
        ], 14, _e))), 256))
      ], 4)) : h("", !0),
      t.$slots.source ? (s(), r("div", Ce, [
        K(t.$slots, "source", {}, void 0, !0)
      ], 512)) : h("", !0)
    ], 4));
  }
}, Le = /* @__PURE__ */ ue($e, [["__scopeId", "data-v-bda2b20a"]]);
export {
  Le as default
};
